diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 01fc5d2b5..0fc4f0620 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -19,23 +19,26 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tool.ItemToolShears;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Objects;
 import java.util.Random;
 
 public class BlockLogic implements BlockInterface, IItemConvertible {
-    protected final @NotNull AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1).copyUnpooled();
+    protected final @NotNull AABBd bounds = new AABBd(0, 0, 0, 1, 1, 1);
     public final @NotNull Block<?> block;
 
     protected @NotNull Material material;
@@ -82,22 +85,22 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.canPlaceOnSurface();
     }
 
     @Override
-    public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.isCubeShaped();
     }
 
     @Override
-    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.canPlaceOnSurface();
     }
 
     @Override
-    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity) {
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
         return this.getBreakResult(world, dropCause, data, tileEntity);
     }
 
@@ -110,63 +113,63 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     public final void setBlockBounds(final double minX, final double minY, final double minZ, final double maxX, final double maxY, final double maxZ) {
-        this.bounds.set(minX, minY, minZ, maxX, maxY, maxZ);
+        this.bounds.setMin(minX, minY, minZ).setMax(maxX, maxY, maxZ);
     }
 
     @Override
-    public @NotNull AABB getBounds() {
-        return this.bounds.copy();
+    public @NotNull AABBdc getBounds() {
+        return this.bounds/*.AABB_copy()*/;
     }
 
     @Override
-    public @NotNull AABB getBoundsRaw() {
+    public @NotNull AABBd getBoundsRaw() {
         return this.bounds;
     }
 
     @Override
-    public float getBrightness(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public float getBrightness(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return source.getBrightness(tilePos, this.block.emission);
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return source.getLightmapCoord(tilePos, this.block.emission);
     }
 
     @Override
-    public float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.isSolidRender() ? 1.0f : 0.0f;
     }
 
     @Override
-    public @NotNull AABB getSelectionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        return this.getBoundsFromState(source, tilePos).move(tilePos.x, tilePos.y, tilePos.z);
+    public @NotNull AABBdc getSelectionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return this.getBoundsFromState(source, tilePos).translate(tilePos.x(), tilePos.y(), tilePos.z(), new AABBd());
     }
 
     @Override
-    public @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull AABB aabb, final @NotNull List<@NotNull AABB> aabbList) {
+    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull AABBdc aabb, final @NotNull List<@NotNull AABBdc> aabbList) {
         this.addIntersectingBoundingBox(aabb, this.getCollisionAABB(world, tilePos), aabbList);
     }
 
-    protected void addIntersectingBoundingBox(final @NotNull AABB sourceAABB, final @Nullable AABB aabbToAdd, final @NotNull List<@NotNull AABB> aabbList) {
-        if (aabbToAdd != null && sourceAABB.intersects(aabbToAdd)) {
+    protected void addIntersectingBoundingBox(final @NotNull AABBdc sourceAABB, final @Nullable AABBdc aabbToAdd, final @NotNull List<@NotNull AABBdc> aabbList) {
+        if (aabbToAdd != null && sourceAABB.intersectsAABB((AABBd) aabbToAdd)) { // TODO idk why JOML takes an AABBd instead of an AABBdc here, note for something in a potential fork
             aabbList.add(aabbToAdd);
         }
     }
 
     @Override
-    public boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePosc tilePos) {
         return true;
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        return this.getBoundsFromState(source, tilePos).move(tilePos.x, tilePos.y, tilePos.z);
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return this.getBoundsFromState(source, tilePos).translate(tilePos.x(), tilePos.y(), tilePos.z(), new AABBd());
     }
 
     @Override
@@ -190,13 +193,13 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) { }
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) { }
 
     @Override
-    public void animationTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) { }
+    public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) { }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) { }
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) { }
 
     @Override
     public int tickDelay() {
@@ -204,16 +207,16 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) { }
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) { }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) { }
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) { }
 
     @Override
-    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) { }
+    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) { }
 
     @Override
-    public float getStrength(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Player player) {
+    public float getStrength(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Player player) {
         if (this.block.blockHardness < 0.0F) {
             return 0.0F;
         }
@@ -236,23 +239,23 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePos tilePos, @NotNull Vec3 start, @NotNull Vec3 end, final boolean useSelectionAABB) {
-        final @NotNull AABB bounds;
+    public @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePosc tilePos, @NotNull Vector3dc start, @NotNull Vector3dc end, final boolean useSelectionAABB) {
+        final @NotNull AABBdc bounds;
         if (useSelectionAABB) {
-            bounds = this.getSelectionAABB(world, tilePos).move(-tilePos.x, -tilePos.y, -tilePos.z);
+            bounds = this.getSelectionAABB(world, tilePos).translate(-tilePos.x(), -tilePos.y(), -tilePos.z(), new AABBd());
         } else {
             bounds = this.getBoundsFromState(world, tilePos);
         }
 
-        start = start.add(-tilePos.x, -tilePos.y, -tilePos.z);
-        end = end.add(-tilePos.x, -tilePos.y, -tilePos.z);
+        Vector3d startInBlock = start.add(-tilePos.x(), -tilePos.y(), -tilePos.z(), new Vector3d());
+        Vector3d endInBlock = end.add(-tilePos.x(), -tilePos.y(), -tilePos.z(), new Vector3d());
 
-        @Nullable Vec3 minVX = start.clipX(end, bounds.minX);
-        @Nullable Vec3 maxVX = start.clipX(end, bounds.maxX);
-        @Nullable Vec3 minVY = start.clipY(end, bounds.minY);
-        @Nullable Vec3 maxVY = start.clipY(end, bounds.maxY);
-        @Nullable Vec3 minVZ = start.clipZ(end, bounds.minZ);
-        @Nullable Vec3 maxVZ = start.clipZ(end, bounds.maxZ);
+        @Nullable Vector3d minVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.minX(), new Vector3d());
+        @Nullable Vector3d maxVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.maxX(), new Vector3d());
+        @Nullable Vector3d minVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.minY(), new Vector3d());
+        @Nullable Vector3d maxVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.maxY(), new Vector3d());
+        @Nullable Vector3d minVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.minZ(), new Vector3d());
+        @Nullable Vector3d maxVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.maxZ(), new Vector3d());
 
         if (!this.isVecInsideYZBounds(bounds, minVX)) minVX = null;
         if (!this.isVecInsideYZBounds(bounds, maxVX)) maxVX = null;
@@ -261,23 +264,26 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         if (!this.isVecInsideXYBounds(bounds, minVZ)) minVZ = null;
         if (!this.isVecInsideXYBounds(bounds, maxVZ)) maxVZ = null;
 
-        @Nullable Vec3 clip = null;
-        if (minVX != null && (clip == null || start.distanceToSquared(minVX) < start.distanceToSquared(clip))) {
+        @Nullable Vector3d clip = null;
+//        if (minVX != null && (clip == null || startInBlock.distanceSquared(minVX) < startInBlock.distanceSquared(clip))) {
+//            clip = minVX;
+//        }
+        if (minVX != null) {
             clip = minVX;
         }
-        if (maxVX != null && (clip == null || start.distanceToSquared(maxVX) < start.distanceToSquared(clip))) {
+        if (maxVX != null && (clip == null || startInBlock.distanceSquared(maxVX) < startInBlock.distanceSquared(clip))) {
             clip = maxVX;
         }
-        if (minVY != null && (clip == null || start.distanceToSquared(minVY) < start.distanceToSquared(clip))) {
+        if (minVY != null && (clip == null || startInBlock.distanceSquared(minVY) < startInBlock.distanceSquared(clip))) {
             clip = minVY;
         }
-        if (maxVY != null && (clip == null || start.distanceToSquared(maxVY) < start.distanceToSquared(clip))) {
+        if (maxVY != null && (clip == null || startInBlock.distanceSquared(maxVY) < startInBlock.distanceSquared(clip))) {
             clip = maxVY;
         }
-        if (minVZ != null && (clip == null || start.distanceToSquared(minVZ) < start.distanceToSquared(clip))) {
+        if (minVZ != null && (clip == null || startInBlock.distanceSquared(minVZ) < startInBlock.distanceSquared(clip))) {
             clip = minVZ;
         }
-        if (maxVZ != null && (clip == null || start.distanceToSquared(maxVZ) < start.distanceToSquared(clip))) {
+        if (maxVZ != null && (clip == null || startInBlock.distanceSquared(maxVZ) < startInBlock.distanceSquared(clip))) {
             clip = maxVZ;
         }
 
@@ -298,67 +304,67 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
             side = Side.SOUTH;
         }
 
-        return new HitResult.Tile(tilePos, side, clip.add(tilePos.x, tilePos.y, tilePos.z));
+        return new HitResult.Tile(tilePos, side, clip.add(tilePos.x(), tilePos.y(), tilePos.z()));
     }
 
-    private boolean isVecInsideYZBounds(final @NotNull AABB bounds, final @Nullable Vec3 v) {
+    private boolean isVecInsideYZBounds(final @NotNull AABBdc bounds, final @Nullable Vector3dc v) {
         if (v == null) {
             return false;
         }
-        return v.y >= bounds.minY && v.y <= bounds.maxY && v.z >= bounds.minZ && v.z <= bounds.maxZ;
+        return v.y() >= bounds.minY() && v.y() <= bounds.maxY() && v.z() >= bounds.minZ() && v.z() <= bounds.maxZ();
     }
 
-    private boolean isVecInsideXZBounds(final @NotNull AABB bounds, final @Nullable Vec3 v) {
+    private boolean isVecInsideXZBounds(final @NotNull AABBdc bounds, final @Nullable Vector3dc v) {
         if (v == null) {
             return false;
         }
-        return v.x >= bounds.minX && v.x <= bounds.maxX && v.z >= bounds.minZ && v.z <= bounds.maxZ;
+        return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.z() >= bounds.minZ() && v.z() <= bounds.maxZ();
     }
 
-    private boolean isVecInsideXYBounds(final @NotNull AABB bounds, final @Nullable Vec3 v) {
+    private boolean isVecInsideXYBounds(final @NotNull AABBdc bounds, final @Nullable Vector3dc v) {
         if (v == null) {
             return false;
         }
-        return v.x >= bounds.minX && v.x <= bounds.maxX && v.y >= bounds.minY && v.y <= bounds.maxY;
+        return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.y() >= bounds.minY() && v.y() <= bounds.maxY();
     }
 
     @Override
-    public void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePos tilePos) { }
+    public void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePosc tilePos) { }
 
     @Override
-    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return this.canPlaceAt(world, tilePos);
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return world.canPlaceInsideBlock(tilePos);
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         return false;
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) { }
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) { }
 
     @Override
-    public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity walker) { }
+    public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity walker) { }
 
     @Override
-    public void onAttacked(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) { }
+    public void onAttacked(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) { }
 
     @Override
-    public void onEntityInside(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity, final @NotNull Vec3 velocity) { }
+    public void onEntityInside(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity, final @NotNull Vector3d velocityDirection) { }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.getBounds();
     }
 
     @Override
-    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return false;
     }
 
@@ -368,15 +374,15 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void onEntityCollision(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity) { }
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) { }
 
     @Override
-    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return false;
     }
 
     @Override
-    public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity) {
+    public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
         player.addStat(Objects.requireNonNull(this.block.getStat(StatList.STAT_MINED)), 1);
 
         final @Nullable ItemStack heldItemStack = player.inventory.getCurrentItem();
@@ -406,7 +412,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
+    public void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
         if (world.isClientSide)
             return;
 
@@ -435,22 +441,22 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return FullSupport.INSTANCE;
     }
 
     @Override
-    public boolean canStay(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return true;
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         this.onPlacedOnSide(world, tilePos, side, xHit, yHit);
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) { }
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) { }
 
     @Override
     public @NotNull String getLanguageKey(final int data) {
@@ -458,25 +464,25 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void triggerEvent(final @NotNull World world, final @NotNull TilePos tilePos, final int index, final int data) { }
+    public void triggerEvent(final @NotNull World world, final @NotNull TilePosc tilePos, final int index, final int data) { }
 
     @Override
-    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.material.getPushReaction();
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return 0;
     }
 
     @Override
-    public boolean isClimbable(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean isClimbable(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return false;
     }
 
     @Override
-    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePos thisPos, final @NotNull TilePos thatPos) {
+    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
         final @Nullable Block<?> bBlock = world.getBlock(thatPos);
 
         final int thisMeta = world.getBlockData(thisPos);
@@ -486,7 +492,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public @NotNull Side getAttachedSide(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull Side getAttachedSide(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return Side.NONE;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index 225082aa5..3d92fcdec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -11,6 +11,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -22,7 +23,7 @@ public class BlockLogicActivator
     public static final int MASK_POWERED = 0b0000_1000;
 
     public BlockLogicActivator(final @NotNull Block<?> block) {
-        super(block, Material.netherrack);
+        super(block, Materials.NETHERRACK);
         block.withEntity(TileEntityActivator::new);
     }
 
@@ -32,7 +33,7 @@ public class BlockLogicActivator
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if (!world.isClientSide) {
             final @NotNull TileEntityActivator tileEntityActivator = (TileEntityActivator) Objects.requireNonNull(world.getTileEntity(tilePos));
             player.displayActivatorScreen(tileEntityActivator);
@@ -40,7 +41,7 @@ public class BlockLogicActivator
         return true;
     }
 
-    private void useItem(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random random) {
+    private void useItem(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random random) {
         final @NotNull Direction direction = BlockLogicRotatable.getDirectionFromMeta(world.getBlockData(tilePos));
 
         final @NotNull TileEntityActivator activator = (TileEntityActivator) Objects.requireNonNull(world.getTileEntity(tilePos));
@@ -52,18 +53,18 @@ public class BlockLogicActivator
             final double pz = direction.getOffsetZ() * 0.6D + 0.5D;
 
             if (itemStack == null) {
-                final @Nullable Block<?> block = world.getBlock(tilePos.add(direction));
+                final @Nullable Block<?> block = world.getBlock(tilePos.add(direction, new TilePos()));
 
                 if (block != null) {
-                    block.onActivatorInteracted(world, tilePos.add(direction), activator, direction);
+                    block.onActivatorInteracted(world, tilePos.add(direction, new TilePos()), activator, direction);
                 } else {
-                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x, tilePos.y, tilePos.z, "tile.activator.click", 1, 1);
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x(), tilePos.y(), tilePos.z(), "tile.activator.click", 1, 1);
                 }
             } else {
                 final @NotNull Item item = itemStack.getItem();
                 item.onUseByActivator(itemStack, world, activator, random, tilePos, direction, px, py, pz);
                 activator.nullDeadItems();
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x, tilePos.y, tilePos.z, "tile.activator.use", 1, 1);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x(), tilePos.y(), tilePos.z(), "tile.activator.use", 1, 1);
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, direction.getId());
             }
         } else {
@@ -72,7 +73,7 @@ public class BlockLogicActivator
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         final int meta = world.getBlockData(tilePos);
         final boolean hasSignal = this.getNeighborSignal(world, tilePos, BlockLogicRotatable.getDirectionFromMeta(meta));
         final boolean isPowered = (meta & MASK_POWERED) != 0;
@@ -86,27 +87,28 @@ public class BlockLogicActivator
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         this.useItem(world, tilePos, rand);
     }
 
-    private boolean getNeighborSignal(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Direction direction) {
-        if (direction != Direction.DOWN && world.hasSignal(tilePos.down(), Side.BOTTOM)) {
+    private boolean getNeighborSignal(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Direction direction) {
+        TilePos queryPos = new TilePos();
+        if (direction != Direction.DOWN && world.hasSignal(tilePos.add(Direction.DOWN, queryPos), Side.BOTTOM)) {
             return true;
         }
-        if (direction != Direction.UP && world.hasSignal(tilePos.up(), Side.TOP)) {
+        if (direction != Direction.UP && world.hasSignal(tilePos.add(Direction.UP, queryPos), Side.TOP)) {
             return true;
         }
-        if (direction != Direction.NORTH && world.hasSignal(tilePos.north(), Side.NORTH)) {
+        if (direction != Direction.NORTH && world.hasSignal(tilePos.add(Direction.NORTH, queryPos), Side.NORTH)) {
             return true;
         }
-        if (direction != Direction.SOUTH && world.hasSignal(tilePos.south(), Side.SOUTH)) {
+        if (direction != Direction.SOUTH && world.hasSignal(tilePos.add(Direction.SOUTH, queryPos), Side.SOUTH)) {
             return true;
         }
-        if (direction != Direction.EAST && world.hasSignal(tilePos.east(), Side.EAST)) {
+        if (direction != Direction.EAST && world.hasSignal(tilePos.add(Direction.EAST, queryPos), Side.EAST)) {
             return true;
         }
-        if (direction != Direction.WEST && world.hasSignal(tilePos.west(), Side.WEST)) {
+        if (direction != Direction.WEST && world.hasSignal(tilePos.add(Direction.WEST, queryPos), Side.WEST)) {
             return true;
         }
         return world.hasSignal(tilePos, Side.BOTTOM);
